/* StartAffinity 1.3.1 (c) 2006 Adsci Engineering, LLC
 *	info@adsciengineering.com
 *
 *	This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>

/* bit macros */
#define IS_SET(flag, bit)	((flag) & (bit))
#define SET_BIT(var, bit)	((var) |= (bit))

int TellUserError(void);

int main(int argc, char* argv[])
{
	SECURITY_ATTRIBUTES SAProcess,SAThread;
	STARTUPINFO StartupInfo;
	PROCESS_INFORMATION ProcessInfo;
	DWORD procs = 0, system_mask = 0 ,proc_mask = 0;
	OSVERSIONINFO verinfo;

	if (argc < 3)
	{printf("Argument 1: App you wish to start\nArgument 2: Processor IDs, #( 0 - 31 supported)\n\nExample: StartAffinity notepad.exe 0 1\n\nwould start notepad.exe on processors 0 and 1.\n\n");return 1;}
	
	//check operating system
	verinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	if (GetVersionEx(&verinfo) && verinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
	{
		printf("WinNT/2000/XP REQUIRED!\n");
		return 1;
	}
	
	GetProcessAffinityMask(GetCurrentProcess(),&proc_mask,&system_mask);

	for (int i=2; i < argc; i++)
		if (IS_SET(system_mask,( 1 << atoi(argv[i]))))
			SET_BIT(procs, ( 1 << atoi(argv[i]) ) );
		else
			printf("Processor ID: %d is not valid, and will be ignored.\n",atoi(argv[i]));
	
	//handle the security attributes
	SAProcess.nLength = sizeof(SECURITY_ATTRIBUTES);
	SAThread.nLength = sizeof(SECURITY_ATTRIBUTES);

	//by nulling these, we will force CreateProcess to use the default security descriptor
	SAProcess.lpSecurityDescriptor = NULL;
	SAThread.lpSecurityDescriptor = NULL;

	StartupInfo.cb = sizeof(STARTUPINFO);

	GetStartupInfo(&StartupInfo);

	if (CreateProcess(NULL,argv[1],&SAProcess,&SAThread,true,NULL,NULL,NULL,&StartupInfo,&ProcessInfo))
	{
		//set affinity mask
		SetProcessAffinityMask(ProcessInfo.hProcess,procs);

		//close handles
		CloseHandle(ProcessInfo.hProcess);
		CloseHandle(ProcessInfo.hThread);
		return 0;
	}
	else
		return TellUserError();

}

int TellUserError(void){
	int error;
	if(!(error = GetLastError())) return 0; 
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		error,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);

	OutputDebugString((LPCTSTR)lpMsgBuf);
	MessageBox(NULL,(LPCTSTR) lpMsgBuf, "Error", NULL);
	LocalFree( lpMsgBuf );
	return error;
}